use strict;
use XML::Twig;
$"=" ";
my $O;
my $xml_file=$ARGV[0];
my $twig= new XML::Twig( 
    twig_handlers =>{ 
	seg => \&sentence 
    },
    pretty_print => 'indented',
    keep_encoding => 1
    );                   

open(my $X,$xml_file);
my $output=$xml_file;
$output=~ s/seg[1-9]/segS/; 
open($O,">$output");
$twig->parse($X);
$twig->flush($O);    
close($X);
close($O);

# 10-10-26 Implementing here new rules.
sub test_verb{
    my $g=shift;
    my $verb=0;
    if($g->gi=~/(ger)|(verb)|(vaux)/){
	$verb= 1;
    }
    if($g->first_child->gi=~/(ger)|(verb)|(vaux)/){
	$verb= 1;
    }
    if($verb && !$g->is_first_child){
	if( $g->prev_sibling->text=~/^(que)|(cuales)$/ ||($g->prev_sibling->text=~/^se$/ && $g->prev_sibling->prev_sibling->text=~/^que$/)){
	    return 0;
	}

    }
    return $verb;;
}

sub sentence{ 
    my( $twig, $s)= @_;     
    my $nbv;                 
    my @seg;  
    my @children=$s->children;
    my $gl=$children[0];
    my $ge=$children[$#children];
    my $nlv=0;
    for(my $j=0;$j<@children;$j++){
	my $gj=$children[$j];
#	if($gj->gi =~ /(ger)|(verb)|(vaux)/||$gj->first_child->gi=~ /(ger)|(verb)|(vaux)/){
	if(test_verb($gj)){
	    $nlv++;
	}
    }
    my $test;
# 10-10-26 ESJ this line was:
#$g->cut
    for (my $i=@children-1;$i>=0;$i--){
	my $g=$children[$i];
#	if($g->gi =~ /(ger)|(verb)|(vaux)/||$g->first_child->gi=~ /(ger)|(verb)|(vaux)/){
	if(test_verb($g)){
	    $nbv++;
	    $nlv--;
	}
# 10-10-26 ESJ moving $g->cut
	my $rule7=1;
	if($g->gi eq "segD" && $i<@children-1){
	    my $gn=$children[$i+1];
	    if(($g->text=~/y/||$g->text=~/^o$/)&& $gn->text=~/^que$/){
		$rule7=0;
	    }
	}
	$g->cut; 
# 10-10-26 new rule
        if ($g->gi eq "segD" && $nbv && $rule7){
	    $test ++;
	    if($nlv){
		if ($g->text eq ","){
		    $g->former_prev_sibling->insert_new_elt('after', "subseg",@seg);
		    @seg=($g);
		}
		else{
		    unshift(@seg,$g);
		    $g->former_prev_sibling->insert_new_elt('after', "subseg",@seg);
		    @seg=();
		}
		$nbv=0;
	    }
	}
	else{
	    unshift(@seg,$g);
	}
    }
    for my $g(reverse(@seg)){
	$g->paste("first_child",$s);
    }
}
